module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(1);


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }
	
	/*
	* @Author: HoangManhPhu
	* @Date:   2017-11-22 23:20:36
	* @Last Modified by:   Phu Hoang
	* @Last Modified time: 2017-11-23 01:41:21
	*/
	
	var _ = __webpack_require__(2);
	var Promise = __webpack_require__(3);
	var botbuilder = __webpack_require__(4);
	var incoming = __webpack_require__(5);
	var outgoing = __webpack_require__(7);
	var UMM = __webpack_require__(8);
	var actions = __webpack_require__(9);
	
	var msbotfw = null;
	var connector = null;
	
	var outgoingMiddleware = function outgoingMiddleware(event, next) {
	  if (event.platform !== 'msbotfw') {
	    return next();
	  }
	  if (!outgoing[event.type]) {
	    return next('Unsupported event type: ' + event.type);
	  }
	
	  outgoing[event.type](event, next, msbotfw);
	};
	
	module.exports = {
	
	  config: {
	    applicationID: { type: 'string', required: true, env: 'MSBOTFW_APP_ID' },
	    applicationPassword: { type: 'string', required: true, env: 'MSBOTFW_APP_PASSWORD' }
	  },
	
	  init: function init(bp) {
	    bp.middlewares.register({
	      name: 'msbotfw.sendMessages',
	      type: 'outgoing',
	      order: 100,
	      handler: outgoingMiddleware,
	      module: 'botpress-msbotfw',
	      description: 'Sends out messages that targets platform = msbotfw.' + ' This middleware should be placed at the end as it swallows events once sent.'
	    });
	
	    bp.msbotfw = {};
	    _.forIn(actions, function (action, name) {
	      bp.msbotfw[name] = action;
	      var sendName = name.replace(/^create/, 'send');
	      bp.msbotfw[sendName] = Promise.method(function () {
	        var msg = action.apply(this, arguments);
	        msg.__id = new Date().toISOString() + Math.random();
	        var resolver = { event: msg };
	        var promise = new Promise(function (resolve, reject) {
	          resolver.resolve = resolve;
	          resolver.reject = reject;
	        });
	        bp.middlewares.sendOutgoing(msg);
	        return promise;
	      });
	    });
	
	    UMM(bp);
	  },
	
	  ready: function () {
	    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(bp, configurator) {
	      var _this = this;
	
	      var config, connectorConfig, setConfigAndRestart, router;
	      return regeneratorRuntime.wrap(function _callee4$(_context4) {
	        while (1) {
	          switch (_context4.prev = _context4.next) {
	            case 0:
	              _context4.next = 2;
	              return configurator.loadAll();
	
	            case 2:
	              config = _context4.sent;
	              connectorConfig = {};
	
	
	              connectorConfig.appId = config.applicationID || console.error('MSBOTFW_APP_ID is not defined');
	              connectorConfig.appPassword = config.applicationPassword || console.error('MSBOTFW_APP_PASSWORD is not defined');
	
	              connector = new botbuilder.ChatConnector(connectorConfig);
	
	              setConfigAndRestart = function () {
	                var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(newConfigs) {
	                  return regeneratorRuntime.wrap(function _callee$(_context) {
	                    while (1) {
	                      switch (_context.prev = _context.next) {
	                        case 0:
	                          _context.next = 2;
	                          return configurator.saveAll(newConfigs);
	
	                        case 2:
	                          connectorConfig.appId = newConfigs.applicationID;
	                          connectorConfig.appPassword = newConfigs.applicationPassword;
	                          connector = new botbuilder.ChatConnector(connectorConfig);
	
	                        case 5:
	                        case 'end':
	                          return _context.stop();
	                      }
	                    }
	                  }, _callee, _this);
	                }));
	
	                return function setConfigAndRestart(_x3) {
	                  return _ref2.apply(this, arguments);
	                };
	              }();
	
	              router = bp.getRouter('botpress-msbotfw', { auth: false });
	
	
	              router.post('/messages', connector.listen());
	
	              router.get('/config', function () {
	                var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(req, res) {
	                  return regeneratorRuntime.wrap(function _callee2$(_context2) {
	                    while (1) {
	                      switch (_context2.prev = _context2.next) {
	                        case 0:
	                          _context2.t0 = res;
	                          _context2.next = 3;
	                          return configurator.loadAll();
	
	                        case 3:
	                          _context2.t1 = _context2.sent;
	
	                          _context2.t0.json.call(_context2.t0, _context2.t1);
	
	                        case 5:
	                        case 'end':
	                          return _context2.stop();
	                      }
	                    }
	                  }, _callee2, _this);
	                }));
	
	                return function (_x4, _x5) {
	                  return _ref3.apply(this, arguments);
	                };
	              }());
	
	              router.post('/config', function () {
	                var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(req, res) {
	                  return regeneratorRuntime.wrap(function _callee3$(_context3) {
	                    while (1) {
	                      switch (_context3.prev = _context3.next) {
	                        case 0:
	                          setConfigAndRestart(req.body);
	                          _context3.t0 = res;
	                          _context3.next = 4;
	                          return configurator.loadAll();
	
	                        case 4:
	                          _context3.t1 = _context3.sent;
	
	                          _context3.t0.json.call(_context3.t0, _context3.t1);
	
	                        case 6:
	                        case 'end':
	                          return _context3.stop();
	                      }
	                    }
	                  }, _callee3, _this);
	                }));
	
	                return function (_x6, _x7) {
	                  return _ref4.apply(this, arguments);
	                };
	              }());
	
	              router.get('/ping', function (req, res, next) {
	                return res.send('pong');
	              });
	
	              router.get('/', function (req, res, next) {
	                res.send('Server is running');
	                next();
	              });
	
	              msbotfw = new botbuilder.UniversalBot(connector);
	              incoming(bp, msbotfw);
	
	            case 16:
	            case 'end':
	              return _context4.stop();
	          }
	        }
	      }, _callee4, this);
	    }));
	
	    function ready(_x, _x2) {
	      return _ref.apply(this, arguments);
	    }
	
	    return ready;
	  }()
	};

/***/ }),
/* 2 */
/***/ (function(module, exports) {

	module.exports = require("lodash");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

	module.exports = require("bluebird");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

	module.exports = require("botbuilder");

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	/*
	* @Author: HoangManhPhu
	* @Date:   2017-11-22 09:34:29
	* @Last Modified by:   Phu Hoang
	* @Last Modified time: 2017-11-23 01:41:35
	*/
	
	var Users = __webpack_require__(6);
	
	module.exports = function (bp, msbotfw) {
	    var users = Users(bp, msbotfw);
	
	    var sendMessageToIncomingMiddlewares = function sendMessageToIncomingMiddlewares(session, user) {
	        // push the message to the incoming middleware
	        bp.middlewares.sendIncoming({
	            type: session.message.type,
	            text: session.message.text || '',
	            user: user,
	            platform: 'msbotfw',
	            raw: session.message,
	            session: session
	        });
	    };
	    msbotfw.dialog('/', function (session) {
	        users.getOrFetchUserProfile(session).then(function (user) {
	            sendMessageToIncomingMiddlewares(session, user);
	        });
	    });
	};

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }
	
	/*
	* @Author: Phu Hoang
	* @Date:   2017-11-23 00:52:02
	* @Last Modified by:   Phu Hoang
	* @Last Modified time: 2017-11-23 01:41:44
	*/
	
	var _ = __webpack_require__(2);
	
	module.exports = function (bp, messenger) {
	    var getOrFetchUserProfile = function () {
	        var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(session) {
	            var knex, userId, user, profile;
	            return regeneratorRuntime.wrap(function _callee$(_context) {
	                while (1) {
	                    switch (_context.prev = _context.next) {
	                        case 0:
	                            _context.next = 2;
	                            return bp.db.get();
	
	                        case 2:
	                            knex = _context.sent;
	                            userId = session.message.user.id || session.message.address.user.id;
	                            _context.next = 6;
	                            return knex('users').where({
	                                platform: 'msbotfw',
	                                'userId': userId
	                            }).then().get(0).then();
	
	                        case 6:
	                            user = _context.sent;
	
	                            if (!user) {
	                                _context.next = 10;
	                                break;
	                            }
	
	                            bp.db.kvs.set('users/id/msbotfw:' + userId + '/skype_address', session.message.address);
	                            return _context.abrupt('return', dbEntryToProfile(user));
	
	                        case 10:
	                            profile = {
	                                id: userId,
	                                platform: 'msbotfw',
	                                gender: null,
	                                timezone: null,
	                                locale: null,
	                                picture_url: null,
	                                first_name: null,
	                                last_name: null
	                            };
	                            _context.next = 13;
	                            return bp.db.saveUser(profileToDbEntry(profile));
	
	                        case 13:
	
	                            bp.db.kvs.set('users/id/msbotfw:' + userId + '/skype_address', session.message.address);
	
	                            return _context.abrupt('return', profile);
	
	                        case 15:
	                        case 'end':
	                            return _context.stop();
	                    }
	                }
	            }, _callee, this);
	        }));
	
	        return function getOrFetchUserProfile(_x) {
	            return _ref.apply(this, arguments);
	        };
	    }();
	
	    function profileToDbEntry(profile) {
	        return {
	            id: profile.id,
	            platform: 'msbotfw',
	            gender: profile.gender,
	            timezone: profile.timezone,
	            locale: profile.locale,
	            picture_url: profile.profile_pic,
	            first_name: profile.first_name,
	            last_name: profile.last_name
	        };
	    }
	
	    function dbEntryToProfile(db) {
	        return {
	            gender: db.gender,
	            timezone: db.timezone,
	            locale: db.locale,
	            profile_pic: db.picture_url,
	            first_name: db.first_name,
	            last_name: db.last_name,
	            id: db.userId
	        };
	    }
	
	    return { getOrFetchUserProfile: getOrFetchUserProfile };
	};

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	/*
	* @Author: HoangManhPhu
	* @Date:   2017-11-22 23:25:44
	* @Last Modified by:   Phu Hoang
	* @Last Modified time: 2017-11-23 12:07:46
	*/
	
	var _ = __webpack_require__(2);
	var botbuilder = __webpack_require__(4);
	
	var handleText = function handleText(event, next, msbotfw) {
	    if (event.platform !== 'msbotfw' || event.type !== 'text') {
	        return next();
	    }
	    var session = event.session || event.raw.session;
	    var user = event.user;
	    var bp = event.bp;
	    var replied = event.raw;
	    if (session) {
	        if (_.isArray(replied)) {
	            replied.forEach(function (r) {
	                return session.send(r);
	            });
	        } else {
	            session.send(replied);
	        }
	    } else if (user) {
	        var userId = event.user.id || event.user.userId || event.address.user.id;
	        bp.db.kvs.get('users/id/' + userId + '/skype_address').then(function (address) {
	            if (address) {
	                var msg = new botbuilder.Message().address(address);
	                if (_.isArray(replied)) {
	                    replied.forEach(function (r) {
	                        msg.text(r);
	                        msbotfw.send(msg);
	                    });
	                } else {
	                    msg.text(replied);
	                    msbotfw.send(msg);
	                }
	            }
	        });
	    }
	    return next();
	};
	
	var handleAttachment = function handleAttachment(event, next, msbotfw) {
	    if (event.platform !== 'msbotfw' || event.type !== 'attachment') {
	        return next();
	    }
	    var session = event.session || event.raw.session;
	    var user = event.user;
	    var bp = event.bp;
	    var replied = event.raw.message.attachments || event.raw;
	    if (session) {
	
	        var msg = new botbuilder.Message(session);
	
	        if (_.isArray(replied)) {
	            replied.forEach(function (r) {
	                return msg.addAttachment(r);
	            });
	        } else {
	            msg.addAttachment(replied);
	        }
	
	        msbotfw.send(msg);
	    } else if (user) {
	        var userId = event.user.id || event.user.userId || event.address.user.id;
	        bp.db.kvs.get('users/id/' + userId + '/skype_address').then(function (address) {
	            if (address) {
	                var msg = new botbuilder.Message().address(address);
	                if (_.isArray(replied)) {
	                    replied.forEach(function (r) {
	                        msg.addAttachment(r);
	                    });
	                } else {
	                    msg.addAttachment(replied);
	                }
	
	                msbotfw.send(msg);
	            }
	        });
	    }
	    return next();
	};
	
	module.exports = {
	    'text': handleText,
	    'attachment': handleAttachment
	};

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
	
	/*
	* @Author: HoangManhPhu
	* @Date:   2017-11-22 23:25:38
	* @Last Modified by:   Phu Hoang
	* @Last Modified time: 2017-11-23 12:04:18
	*/
	
	var actions = __webpack_require__(9);
	var _ = __webpack_require__(2);
	
	function _processOutgoing(_ref) {
	  var event = _ref.event,
	      blocName = _ref.blocName,
	      instruction = _ref.instruction;
	
	  var ins = Object.assign({}, instruction); // Create a shallow copy of the instruction
	
	  ////////
	  // PRE-PROCESSING
	  ////////
	
	  var optionsList = ['quick_replies', 'waitRead', 'waitDelivery', 'typing', 'tag', '__platformSpecific', 'on'];
	
	  var options = _.pick(instruction, optionsList);
	
	  var _iteratorNormalCompletion = true;
	  var _didIteratorError = false;
	  var _iteratorError = undefined;
	
	  try {
	    for (var _iterator = optionsList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
	      var prop = _step.value;
	
	      delete ins[prop];
	    }
	  } catch (err) {
	    _didIteratorError = true;
	    _iteratorError = err;
	  } finally {
	    try {
	      if (!_iteratorNormalCompletion && _iterator.return) {
	        _iterator.return();
	      }
	    } finally {
	      if (_didIteratorError) {
	        throw _iteratorError;
	      }
	    }
	  }
	
	  if (options.quick_replies) {
	    options.quick_replies = processQuickReplies(options.quick_replies, blocName);
	  }
	
	  /////////
	  /// Processing
	  /////////
	
	  if (!_.isNil(instruction.contentType) || !_.isNil(instruction.attachments)) {
	    if (event.session) {
	      return actions.createAttachment(event.session, ins);
	    } else if (event.user) {
	      return actions.createAttachmentToUser(event.user, ins);
	    }
	  }
	
	  if (!_.isNil(instruction.text)) {
	    if (event.session) {
	      return actions.createText(event.session, instruction.text);
	    } else if (event.user) {
	      return actions.createTextToUser(event.user, instruction.text);
	    }
	  }
	
	  ////////////
	  /// POST-PROCESSING
	  ////////////
	
	  // Nothing to post-process yet
	
	  ////////////
	  /// INVALID INSTRUCTION
	  ////////////
	
	  var strRep = util.inspect(instruction, false, 1);
	  throw new Error('Unrecognized instruction on Bot Framework in bloc \'' + blocName + '\': ' + strRep);
	}
	
	function getTemplates() {
	  return [];
	}
	
	module.exports = function (bp) {
	  var _$at = _.at(bp, ['umm', 'umm.registerConnector']),
	      _$at2 = _slicedToArray(_$at, 2),
	      umm = _$at2[0],
	      registerConnector = _$at2[1];
	
	  umm && registerConnector && registerConnector({
	    platform: 'msbotfw',
	    processOutgoing: function processOutgoing(args) {
	      return _processOutgoing(Object.assign({}, args, { bp: bp }));
	    },
	    templates: getTemplates()
	  });
	};

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	/*
	* @Author: HoangManhPhu
	* @Date:   2017-11-22 13:07:34
	* @Last Modified by:   Phu Hoang
	* @Last Modified time: 2017-11-27 00:10:43
	*/
	
	var Promise = __webpack_require__(3);
	var _ = __webpack_require__(2);
	
	var create = function create(obj) {
	  var resolve = null;
	  var reject = null;
	  var promise = new Promise(function (r, rj) {
	    resolve = r;
	    reject = rj;
	  });
	
	  var messageId = new Date().toISOString() + Math.random();
	
	  var newEvent = Object.assign({
	    _promise: promise,
	    _resolve: resolve,
	    _reject: reject,
	    __id: messageId
	  }, obj);
	
	  return newEvent;
	};
	
	var createText = function createText(session, message) {
	  return {
	    platform: 'msbotfw',
	    type: 'text',
	    text: 'msbotfw',
	    raw: message,
	    session: session
	  };
	};
	
	var createTextToUser = function createTextToUser(user, message) {
	  return {
	    platform: 'msbotfw',
	    type: 'text',
	    text: 'msbotfw',
	    raw: message,
	    user: user
	  };
	};
	
	var createAttachment = function createAttachment(session, object) {
	  var data = object.contentType ? { attachments: [object] } : object;
	
	  // console.log(data)
	
	  return create({
	    platform: 'msbotfw',
	    type: 'attachment',
	    text: typeof object === 'string' ? object : _.get(data, 'attachments[0].content.text') || object.text || 'N/A',
	    user: session.user,
	    raw: {
	      session: session,
	      message: data
	    }
	  });
	};
	
	var createAttachmentToUser = function createAttachmentToUser(user, object) {
	  var data = object.contentType ? { attachments: [object] } : object;
	
	  return create({
	    platform: 'msbotfw',
	    type: 'attachment',
	    text: typeof object === 'string' ? object : _.get(data, 'attachments[0].content.text') || object.text || 'N/A',
	    user: user,
	    raw: {
	      message: data
	    }
	  });
	};
	
	module.exports = {
	  createText: createText,
	  createTextToUser: createTextToUser,
	  createAttachment: createAttachment,
	  createAttachmentToUser: createAttachmentToUser
	};

/***/ })
/******/ ]);
//# sourceMappingURL=node.bundle.js.map